<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>

  <meta content="text/html; charset=ISO-8859-1" http-equiv="content-type">
  <title>ADC</title>


</head>

<body>

<h1 style="text-align: center;">ADC</h1>

<br>

<a href="read_value.cgi" target="_blank">Leggi Valori Attuali&nbsp;</a>&nbsp;&nbsp;
&nbsp;&nbsp;&nbsp; <a href="graph.cgi?graph=value" target="_blank">Visualizza Grafico</a>&nbsp;&nbsp;&nbsp;
&nbsp;&nbsp;&nbsp; <a href="csv" target="_blank">Scarica CSV</a><br>

<br>

<script src='jquery.min.js'></script>
<script>
$(function () {

<?php

for($i=1;$i<=8;$i++){
  print "    var checkbox".$i." = $('#triggerCH".$i."');";
  print "    var hidden".$i." = $('#CH".$i."');";
  //print "    hidden".$i.".hide();";
  print "    if (checkbox".$i.".is(':checked')) {";
  print "         hidden".$i.".show();";
  print "    } else {";
  print "        hidden".$i.".hide();";
  print "    }";
  print "    checkbox".$i.".change(function () {";
  print "        if (checkbox".$i.".is(':checked')) {";
  print "            hidden".$i.".show();";
  print "        } else {";
  print "            hidden".$i.".hide();";
  print "        }";
  print "    });";
}    
?>
});
//@ sourceURL=pen.js
</script>




<?php

 //var_dump($_POST["unit_in5"]);
 //var_dump($_POST);

  $start_button="";
  $stop_button="";
  if (file_exists('/var/run/cpi3adc.pid'))
    $PID = file_get_contents('/var/run/cpi3adc.pid');


    
   
if (!empty($_POST)){

    $scala_min =  $_POST["scala_min"];
    $scala_max =  $_POST["scala_max"];
    $in_min =  $_POST["in_min"];
    $in_max =  $_POST["in_max"];
    $adc_min =  $_POST["adc_min"];
    $adc_max =  $_POST["adc_max"];
    $unit = $_POST["unit"];
    $unit_in = $_POST["unit_in"];
    $media = $_POST["media"];
    $interval = $_POST["interval"];
    
    for($i=1;$i<=8;$i++){
      if(isset ($_POST["question".$i])){
        //print $i;
        $Canale[$i]["global"] = false;
        $Canale[$i]["scala_min"] =  $_POST["scala_min".$i];
        $Canale[$i]["scala_max"] =  $_POST["scala_max".$i];
        $Canale[$i]["in_min"] =  $_POST["in_min".$i];
        $Canale[$i]["in_max"] =  $_POST["in_max".$i];
        $Canale[$i]["adc_min"] =  $_POST["adc_min".$i];
        $Canale[$i]["adc_max"] =  $_POST["adc_max".$i];
        $Canale[$i]["unit"] = $_POST["unit".$i];
        $Canale[$i]["unit_in"] = $_POST["unit_in".$i];
        //print $Canale[$i]["unit_in"];
      }
      else{
        $Canale[$i]["global"] = true;
        $Canale[$i]["scala_min"] =  $_POST["scala_min"];
        $Canale[$i]["scala_max"] =  $_POST["scala_max"];
        $Canale[$i]["in_min"] =  $_POST["in_min"];
        $Canale[$i]["in_max"] =  $_POST["in_max"];
        $Canale[$i]["adc_min"] =  $_POST["adc_min"];
        $Canale[$i]["adc_max"] =  $_POST["adc_max"];
        $Canale[$i]["unit"] = $_POST["unit"];
        $Canale[$i]["unit_in"] = $_POST["unit_in"];
      }
    }
    
    //var_dump($Canale);
    
    if(isset($_POST["start"])){
      if(system("/usr/bin/sudo /usr/local/bin/cpi3adc.py > /dev/null") == "")
        echo "<div style=\"text-align: center;\"><h3>Raccoglitore avviato con successo</h3></div>";
      else
        echo "<div style=\"text-align: center;\"><h3>ATTENZIONE! - Avvio fallito</h3></div>"; 
      //sleep(1);
      $PID = file_get_contents('/var/run/cpi3adc.pid'); 
    }
    
    if(isset($_POST["stop"])){
      $ret = system("/usr/bin/sudo /bin/kill " . $PID);
      //var_dump($ret);
      if($ret == "")
        echo "<div style=\"text-align: center;\"><h3>Raccoglitore fermato</h3></div>"; 
      else
        echo "<div style=\"text-align: center;\"><h3>ATTENZIONE! - Fermo non riuscito</h3></div>";  
    }
    
    if(isset($_POST["clear"])){
      system("/usr/bin/sudo /bin/rm /var/www/adc/csv/adc.csv");
      system("/usr/bin/sudo /bin/rm /var/www/adc/csv/volt.csv");
      system("/usr/bin/sudo /bin/rm /var/www/adc/csv/in.csv");
      system("/usr/bin/sudo /bin/rm /var/www/adc/csv/value.csv");
    }
    
    if(isset($_POST["save"])){
      $file_content = "#!/usr/bin/env python\n# -*- coding: utf-8 -*-\n\n";
      
      $file_content .= "SCALA_MIN=".$scala_min."\n";
      $file_content .= "SCALA_MAX=".$scala_max."\n";
      $file_content .= "IN_MIN=".$in_min."\n";
      $file_content .= "IN_MAX=".$in_max."\n";
      $file_content .= "ADC_MIN=".$adc_min."\n";
      $file_content .= "ADC_MAX=".$adc_max."\n";
  
      $file_content .= "UNIT_INGRESSO=\"".$unit_in."\"\n";
      $file_content .= "UNIT_STRUMENTO=\"".$unit."\"\n";
      $file_content .= "MEDIA=".$media."\n";
      $file_content .= "INTERVALLO=".$interval."\n";
      
      $file_content .= "\n\n";
      
      //calcolo dei valori
      $NUMERATORE =  $scala_max;
      $DENOMINATORE =  ($adc_max - $adc_min);
      $OFFSET = ($NUMERATORE / $DENOMINATORE * $adc_min);
      
      $file_content .= "NUMERATORE=".$NUMERATORE."\n";
      $file_content .= "DENOMINATORE=".$DENOMINATORE."\n";
      $file_content .= "OFFSET=".$OFFSET."\n";
      $file_content .= "MOLTIPLICATORE_IN=".$in_max/$adc_max."\n";
      
      //adesso procediamo per ogni valore
      for($i=1;$i<=8;$i++){
        $file_content .= "\n\n";
        if($Canale[$i]["global"] == true){
//           $file_content .= "SCALA_MIN".$i."=".$scala_min."\n";
//           $file_content .= "SCALA_MAX".$i."=".$scala_max."\n";
//           $file_content .= "IN_MIN".$i."=".$in_min."\n";
//           $file_content .= "IN_MAX".$i."=".$in_max."\n";
//           $file_content .= "ADC_MIN".$i."=".$adc_min."\n";
//           $file_content .= "ADC_MAX".$i."=".$adc_max."\n";
          $file_content .= "NUM".$i."=NUMERATORE\n";
          $file_content .= "DEN".$i."=DENOMINATORE\n";
          $file_content .= "OFF".$i."=OFFSET\n";
          $file_content .= "MOLT_IN".$i."=MOLTIPLICATORE_IN\n";
          $file_content .= "UNIT_IN".$i."=UNIT_INGRESSO\n";
          $file_content .= "UNIT_STR".$i."=UNIT_STRUMENTO\n";
        
        }
        else{
          $file_content .= "SCALA_MIN".$i."=".$Canale[$i]["scala_min"]."\n";
          $file_content .= "SCALA_MAX".$i."=".$Canale[$i]["scala_max"]."\n";
          $file_content .= "IN_MIN".$i."=".$Canale[$i]["in_min"]."\n";
          $file_content .= "IN_MAX".$i."=".$Canale[$i]["in_max"]."\n";
          $file_content .= "ADC_MIN".$i."=".$Canale[$i]["adc_min"]."\n";
          $file_content .= "ADC_MAX".$i."=".$Canale[$i]["adc_max"]."\n";
                //calcolo dei valori
          $Canale[$i]["NUM"] =  $Canale[$i]["scala_max"];
          $Canale[$i]["DEN"] =  ($Canale[$i]["adc_max"] - $Canale[$i]["adc_min"]);
          $Canale[$i]["OFF"] = ($Canale[$i]["NUM"] / $Canale[$i]["DEN"] * $Canale[$i]["adc_min"]);
          //print $i;
          //print $Canale[$i]["unit_in"];
          
          
          $file_content .= "NUM".$i."=".$Canale[$i]["NUM"]."\n";
          $file_content .= "DEN".$i."=".$Canale[$i]["DEN"]."\n";
          $file_content .= "OFF".$i."=".$Canale[$i]["OFF"]."\n";
          $file_content .= "MOLT_IN".$i."=".$Canale[$i]["in_max"]/$Canale[$i]["adc_max"]."\n";
          $file_content .= "UNIT_IN".$i."=\"".$Canale[$i]["unit_in"]."\"\n";
          $file_content .= "UNIT_STR".$i."=\"".$Canale[$i]["unit"]."\"\n";        
        
        }
        
      }
      
      
      $etc_content = "# Enable automatic start of cpi3adc\n# write 1 to enable it or 0 to disable\nSTART=";
      if(isset($_POST["startup"]))
        $etc_content .= "1\n";
      else
        $etc_content .= "0\n";  

      file_put_contents("/etc/default/cpi3adc", $etc_content);
      
      
      if(file_put_contents("/usr/local/lib/cpi3adc/adc_value.py", $file_content))
        echo "<div style=\"text-align: center;\"><h3>Salvataggio valori avvenuto con successo</h3></div>";
      else
        echo "<div style=\"text-align: center;\"><h3>ERRORE nel salvataggio dati</h3></div>";
      
    }
}
else{

    

//     $scala_min =  0;
//     $scala_max =  100;
//     $in_min =  4;
//     $in_max =  20;
//     $adc_min =  655;
//     $adc_max =  3269;
//     $unit = "C";
//     $unit_in = "mA";
//     $media = 1;
//     $interval = 10;

    $adc_value = parse_ini_file("/usr/local/lib/cpi3adc/adc_value.py");
    //var_dump  ($adc_value);
    $scala_min =  $adc_value["SCALA_MIN"];
    $scala_max =  $adc_value["SCALA_MAX"];
    $in_min =  $adc_value["IN_MIN"];
    $in_max =  $adc_value["IN_MAX"];
    $adc_min =  $adc_value["ADC_MIN"];
    $adc_max =  $adc_value["ADC_MAX"];
    $unit = $adc_value["UNIT_STRUMENTO"];
    $unit_in = $adc_value["UNIT_INGRESSO"];
    $media = $adc_value["MEDIA"];
    $interval = $adc_value["INTERVALLO"];
    
      //adesso procediamo per ogni valore
      for($i=1;$i<=8;$i++){
        if($adc_value["NUM".$i] == "NUMERATORE"){
          $Canale[$i]["global"] = true;
          $Canale[$i]["scala_min"] =  $scala_min;
          $Canale[$i]["scala_max"] =  $scala_max;
          $Canale[$i]["in_min"] =  $in_min;
          $Canale[$i]["in_max"] =  $in_max;
          $Canale[$i]["adc_min"] =  $adc_min;
          $Canale[$i]["adc_max"] =  $adc_max;
          $Canale[$i]["unit"] = $unit;
          $Canale[$i]["unit_in"] = $unit_in;
        }
        else{
          $Canale[$i]["global"] = false;
          $Canale[$i]["scala_min"] =  $adc_value["SCALA_MIN".$i];
          $Canale[$i]["scala_max"] =  $adc_value["SCALA_MAX".$i];
          $Canale[$i]["in_min"] =  $adc_value["IN_MIN".$i];
          $Canale[$i]["in_max"] =  $adc_value["IN_MAX".$i];
          $Canale[$i]["adc_min"] =  $adc_value["ADC_MIN".$i];
          $Canale[$i]["adc_max"] =  $adc_value["ADC_MAX".$i];
          $Canale[$i]["unit"] = $adc_value["UNIT_STR".$i];
          $Canale[$i]["unit_in"] = $adc_value["UNIT_IN".$i];    
        
        }
        
      }
    
}

?>

<form method="post" action="index.php" name="set_value">

<?php

  //echo $PID;
  if(isset($PID) && posix_getpgid($PID))
    $start_button="disabled";
  else
    $stop_button="disabled";
    
  $ini_array = parse_ini_file("/etc/default/cpi3adc");
  if ($ini_array["START"] != 0)
    $auto_start = "checked";
  else
    $auto_start = "";

?>


<input name="start" value="Avvia" type="submit" <?php print $start_button ?> >
<input name="stop" value="Ferma" type="submit" <?php print $stop_button ?> >
<input name="clear" value="Cancella CSV" onclick="return confirm('Sei sicuro?');" type="submit"> 
 
    <br>
     <br>
Parametri
Globali:<br>
<input name="startup" value="true" type="checkbox" <?php print $auto_start ?> >Avvia
automaticamente <br>

  <table style="text-align: left; width: 528px; height: 88px;" border="1" cellpadding="2" cellspacing="2">

    <tbody>

      <tr>

        <td style="width: 137px; text-align: center;">Scala</td>

        <td style="width: 180px; text-align: center;">Ingresso</td>

        <td style="width: 183px; text-align: center;">Valore
lettura ADC</td>

      </tr>

      <tr>

        <td style="width: 137px; text-align: center;"><input name="scala_min" value="<?php echo $scala_min; ?>"></td>

        <td style="width: 180px; text-align: center;"><input name="in_min" value="<?php echo $in_min; ?>"></td>

        <td style="width: 183px; text-align: center;"><input name="adc_min" value="<?php echo $adc_min; ?>"></td>

      </tr>

      <tr>

        <td style="width: 137px; text-align: center;"><input name="scala_max" value="<?php echo $scala_max; ?>"></td>

        <td style="width: 180px; text-align: center;"><input name="in_max" value="<?php echo $in_max; ?>"></td>

        <td style="width: 183px; text-align: center;"><input name="adc_max" value="<?php echo $adc_max; ?>"></td>

      </tr>

    </tbody>
  </table>

  <br>

Unit di misura strumento: <input name="unit" value="<?php echo $unit; ?>">&nbsp;&nbsp;
Unit di misura ingresso: <input name="unit_in" value="<?php echo $unit_in; ?>">&nbsp;&nbsp;

<br>
Nr di valori per media: <input name="media" value="<?php echo $media; ?>">&nbsp;&nbsp;
Intervallo in secondi per letture: <input name="interval" value="<?php echo $interval; ?>">&nbsp;&nbsp;
<br><i>Per la lettura di tutti i valori occorrono circa 0.4 secondi</i>

<br>

<?php
for($i=1;$i<=8;$i++){

  if($Canale[$i]["global"]== true)
    $check = "";
  else
    $check = "checked";
  print "<br><div>  CH".$i." diverso da parametri globali?: <input type=\"checkbox\" id=\"triggerCH".$i."\" ".$check." name=\"question".$i."\"></div>\n";
  print "<div id=\"CH".$i."\">\n";
  print "<table style=\"text-align: left; width: 528px; height: 88px;\" border=\"1\" cellpadding=\"2\" cellspacing=\"2\"> \n";
  print "  <tbody>   <tr>    <td style=\"width: 137px; text-align: center;\">Scala CH".$i."\n";
  print "</td> <td style=\"width: 180px; text-align: center;\">Ingresso CH".$i."</td>\n";
  print "<td style=\"width: 183px; text-align: center;\">Valore lettura ADC CH".$i."</td></tr>\n";
  print "<tr><td style=\"width: 137px; text-align: center;\"><input name=\"scala_min".$i."\" value=\"".$Canale[$i]["scala_min"]."\"></td>\n";
  print "<td style=\"width: 137px; text-align: center;\"><input name=\"in_min".$i."\" value=\"".$Canale[$i]["in_min"]."\"></td>\n";
  print "<td style=\"width: 137px; text-align: center;\"><input name=\"adc_min".$i."\" value=\"".$Canale[$i]["adc_min"]."\"></td>\n";
  print "</tr>    <tr>\n";
  print "<td style=\"width: 137px; text-align: center;\"><input name=\"scala_max".$i."\" value=\"".$Canale[$i]["scala_max"]."\"></td>\n";
  print "<td style=\"width: 137px; text-align: center;\"><input name=\"in_max".$i."\" value=\"".$Canale[$i]["in_max"]."\"></td>\n";
  print "<td style=\"width: 137px; text-align: center;\"><input name=\"adc_max".$i."\" value=\"".$Canale[$i]["adc_max"]."\"></td>\n";
  print "   </tr>  </tbody> </table> <br>\n";
  print "Unit di misura strumento: <input name=\"unit".$i."\" value=\"".$Canale[$i]["unit"]."\">\n";
  print "Unit di misura ingresso: <input name=\"unit_in".$i."\" value=\"".$Canale[$i]["unit_in"]."\">\n";
  print "</div><br>";

}

 ?>   
  

  <div style="text-align: center;"><input name="save" value="Salva Valori" type="submit"><br>

  </div>

</form>

<br>

<br>

</body>
</html>
